interface InferenceRulesDirectiveCtrl {
  rules: InferenceRule[];
  selectedRule: InferenceRule;
  applyRule(rule: InferenceRule): void;
}

function InferenceRulesDirective(): ng.IDirective {
  return {
    restrict: 'E',
    scope: {
      rules: '=',
      selectedRule: '=',
      applyRule: '&'
    },
    controller: ['$scope', function($scope: any) {
      this.rules = $scope.rules;
      
      $scope.$watch('selectedRule', (rule: InferenceRule) => {
        this.selectedRule = rule;
      });
      
      this.applyRule = (rule: InferenceRule) => {
        $scope.applyRule({rule: rule});
      };
    }]
  };
}

function InferenceRuleDirective(): ng.IDirective {
  return {
    restrict: 'E',
    require: '^axInferenceRules',
    scope: true,
    template: '<div class="main">\n  <div class="top">\n    <span class="sequent" ng-repeat="sequent in rule.top.split(\';\')">{{sequent}}<span ng-if="!sequent">&nbsp;</span></span>\n  </div>\n  <div class="bottom sequent">{{rule.bottom}}</div>\n</div>\n<div class="symbol">(<span class="sequent" ng-bind-html="rule.symbolHtml"></span>)</div>',
    link: (scope: any, element: JQuery, attrs: ng.IAttributes, rulesCtrl: InferenceRulesDirectiveCtrl) => {
      scope.$watch(() => rulesCtrl.rules, () => {
        scope.rule = rulesCtrl.rules.filter(rule => rule.symbol == attrs['ruleId']).reduce((_, rule) => rule, null);
      }, true);
      
      scope.$watch(() => rulesCtrl.selectedRule, (selectedRule: InferenceRule) => {
        element.toggleClass('selected', typeof selectedRule != 'undefined' && scope.rule == selectedRule);
      });
      
      element.on('click', () => { rulesCtrl.applyRule(scope.rule); });
    }
  };
}