interface StorageService {
  length: number;
  get(key: string): any;
  set(key: string, value: any): void;
  remove(key: string): void;
  clear(): void;
}

class LocalStorageService implements StorageService {
  static $inject = ['$window'];
  constructor(private $window: ng.IWindowService) {}
  
  get length(): number {
    return this.$window.localStorage.length;
  }

  get(key: string): any {
    return JSON.parse(this.$window.localStorage.getItem(key));
  }

  set(key: string, value: any): void {
    this.$window.localStorage.setItem(key, JSON.stringify(value));
  }

  remove(key: string): void {
    this.$window.localStorage.removeItem(key);
  }

  clear(): void {
    this.$window.localStorage.clear();
  }
}