package ee.ut.axiom;

import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.glassfish.hk2.api.Factory;
import org.glassfish.jersey.server.CloseableService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Dmitri Gabbasov
 */
class AxiomEntityManagerFactory implements Factory<EntityManager> {
  private static Logger log = LoggerFactory.getLogger(AxiomEntityManagerFactory.class);

  @Inject
  private EntityManagerFactory emf;

  @Override
  public EntityManager provide() {
    EntityManager em = emf.createEntityManager();
    em.getTransaction().begin();
    
    log.trace("Created {}", em);

    return em;
  }

  @Override
  public void dispose(EntityManager em) {
    log.trace("Closing {}", em);
    
    if (em.getTransaction().isActive())
      em.getTransaction().commit();
    em.close();
  }
}
