package ee.ut.axiom;

import java.security.Principal;
import javax.ws.rs.core.SecurityContext;

import ee.ut.axiom.models.User;

/**
 * @author Dmitri Gabbasov
 */
public class AxiomSecurityContext implements SecurityContext {
  public static final String AUTH_SCHEME = "AUTH_TOKEN";
  
  private SecurityContext parent;
  private User user;

  public AxiomSecurityContext(SecurityContext parent, User user) {
    this.parent = parent;
    this.user = user;
  }

  @Override
  public Principal getUserPrincipal() {
    return user;
  }

  @Override
  public boolean isUserInRole(String role) {
    return user != null && user.isInRole(role);
  }

  @Override
  public boolean isSecure() {
    return parent != null && parent.isSecure();
  }

  @Override
  public String getAuthenticationScheme() {
    return AUTH_SCHEME;
  }
}
