package ee.ut.axiom.constraints;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;

import ee.ut.axiom.models.User;
import ee.ut.axiom.repositories.UserRepository;

/**
 * @author Dmitri Gabbasov
 */
public class NonExistingUserValidator implements ConstraintValidator<NonExisting, User> {
  @Inject
  Provider<UserRepository> users;

  @Override
  public void initialize(NonExisting nonExisting) {
    
  }

  @Override
  public boolean isValid(User user, ConstraintValidatorContext constraintValidatorContext) {
    return user.uid == null || !users.get().findByUid(user.uid).isPresent();
  }
}
