package ee.ut.axiom.constraints;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;

import com.google.common.base.Joiner;

import ee.ut.axiom.sequentCalculus.ParseException;
import ee.ut.axiom.sequentCalculus.PredicateArityMismatchException;
import ee.ut.axiom.util.ParseExceptionMessage;

/**
 * @author Dmitri Gabbasov
 */
public class SequentValidator implements ConstraintValidator<Sequent, String> {

  @Override
  public void initialize(Sequent sequent) {
    
  }

  @Override
  public boolean isValid(String s, ConstraintValidatorContext constraintValidatorContext) {
    if (s == null)
      return false;
    
    try {
      ee.ut.axiom.sequentCalculus.Sequent.parse(s);
    }
    catch (ParseException e) {
      String key = ParseExceptionMessage.of(e);
      constraintValidatorContext.disableDefaultConstraintViolation();
      constraintValidatorContext.buildConstraintViolationWithTemplate(key).addConstraintViolation();
      return false;
    }
    return true;
  }
}
