package ee.ut.axiom.filters;

import java.io.IOException;
import javax.annotation.Priority;
import javax.inject.Inject;
import javax.inject.Provider;
import javax.ws.rs.Priorities;
import javax.ws.rs.container.ContainerRequestContext;
import javax.ws.rs.container.ContainerRequestFilter;
import javax.ws.rs.container.PreMatching;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.SecurityContext;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ee.ut.axiom.AxiomSecurityContext;
import ee.ut.axiom.repositories.UserRepository;

/**
 * @author Dmitri Gabbasov
 */
@javax.ws.rs.ext.Provider
@PreMatching
public class AuthenticationFilter implements ContainerRequestFilter {
  private static Logger log = LoggerFactory.getLogger(AuthenticationFilter.class);

  @Inject
  Provider<UserRepository> users;
  
  public void filter(ContainerRequestContext requestContext) throws IOException {
    MultivaluedMap<String,String> params = requestContext.getUriInfo().getQueryParameters();
    String token = params.getFirst("token");

    SecurityContext securityContext = requestContext.getSecurityContext();
    requestContext.setSecurityContext(
        new AxiomSecurityContext(securityContext, users.get().findByToken(token).orElse(null)));
  }
}
