package ee.ut.axiom.models;

import java.util.Date;
import java.util.Random;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.xml.bind.annotation.XmlTransient;

import org.apache.commons.codec.binary.Hex;

/**
 * @author Dmitri Gabbasov
 */
@Entity
public class AuthToken {
  @Id
  @Column(length = 32)
  public String token;
  
  @XmlTransient
  @ManyToOne(optional = false)
  public User user;
  
  @Temporal(TemporalType.TIMESTAMP)
  public Date expires;

  public AuthToken() {
  }

  public AuthToken(String token, User user, Date expires) {
    this.token = token;
    this.user = user;
    this.expires = expires;
  }

  public static AuthToken createRandomToken(User user, Date expires) {
    byte[] bytes = new byte[16];
    new Random().nextBytes(bytes);
    return new AuthToken(Hex.encodeHexString(bytes), user, expires);
  }
}
