package ee.ut.axiom.models;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.annotation.XmlTransient;

import ee.ut.axiom.constraints.Sequent;

/**
 * @author Dmitri Gabbasov
 */
@Entity
public class Task {
  @Id @GeneratedValue
  public int id;

  @Sequent(message = "sequentCalculus.ParseError")
  @Column(nullable = false, length = 200)
  public String sequent;
  
  public int steps;
  
  @Column(length = 2000)
  public String text;
  
  @XmlTransient
  @ManyToOne(optional = false)
  public Taskset taskset;
  
  @XmlTransient
  @OneToMany(cascade = CascadeType.ALL, mappedBy = "task", orphanRemoval = true)
  public List<Solution> solutions = new ArrayList<>();
  
  void afterUnmarshal(Unmarshaller unmarshaller, Object parent) {
    taskset = (Taskset) parent;
  }

  @Override
  public String toString() {
    return "Task{" +
        "id=" + id +
        ", sequent='" + sequent + '\'' +
        ", steps=" + steps +
        ", text='" + text + '\'' +
        ", taskset=" + (taskset == null ? "null" : taskset.id) +
        '}';
  }
}

