package ee.ut.axiom.models;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.OrderColumn;
import javax.xml.bind.annotation.XmlTransient;

import org.hibernate.validator.constraints.NotBlank;
import org.hibernate.validator.constraints.NotEmpty;

/**
 * @author Dmitri Gabbasov
 */
@Entity
public class Taskset {
  @Id @GeneratedValue
  public int id;
  
  @NotBlank(message = "tasksets.errors.EmptyTasksetName")
  @Column(nullable = false, length = 200)
  public String name;
  
  @Column(length = 50)
  public String password;
  
  @NotEmpty(message = "tasksets.errors.EmptyTaskList")
  @OneToMany(cascade = CascadeType.ALL, mappedBy = "taskset", orphanRemoval = true)
  @OrderColumn
  public List<Task> tasks = new ArrayList<>();
  
  public boolean open;
  
  @XmlTransient
  @OneToOne(cascade = CascadeType.ALL, optional = false, mappedBy = "taskset", orphanRemoval = true)
  public TasksetPlacement placement;
  
  public boolean lemmasAllowed;

  @Override
  public String toString() {
    return "Taskset{" +
        "id=" + id +
        ", name='" + name + '\'' +
        ", password='" + password + '\'' +
        ", tasks=" + tasks +
        ", open=" + open +
        ", lemmasAllowed=" + lemmasAllowed +
        '}';
  }
}
