package ee.ut.axiom.repositories;

import java.sql.Date;
import java.time.Instant;
import javax.inject.Inject;
import javax.persistence.EntityManager;

import org.jvnet.hk2.annotations.Service;
import com.google.gson.Gson;

import ee.ut.axiom.models.Solution;
import ee.ut.axiom.models.Task;
import ee.ut.axiom.models.User;
import ee.ut.axiom.sequentCalculus.DerivationNode;

/**
 * @author Dmitri Gabbasov
 */
@Service
public class SolutionRepository {
  private EntityManager em;

  @Inject
  public SolutionRepository(EntityManager em) {
    this.em = em;
  }

  public Solution getSolution(int taskId, String userId) {
    return em.createQuery("select s from Solution s join s.task t join s.user u where t.id=:taskId and u.uid=:userId",
        Solution.class).setParameter("taskId", taskId).setParameter("userId", userId).getSingleResult();
  }

  public Solution create(int taskId, String userId) {
    Solution solution = new Solution();
    solution.task = em.find(Task.class, taskId);
    solution.user = em.find(User.class, userId);
    solution.created = Date.from(Instant.now());

    solution.derivation = new Gson().toJson(new DerivationNode(solution.task.sequent));
    
    em.persist(solution);
    return solution;
  }
}
