package ee.ut.axiom.sequentCalculus;

import java.util.Map;
import java.util.Set;

import com.google.common.collect.SetMultimap;

/**
 * @author Dmitri Gabbasov
 */
public interface Formula {
  int priority();
  
  Set<Character> getVariables();
  
  SetMultimap<Character, Integer> getPredicates();

  void renameVariable(char oldVar, char newVar);
  
  boolean evaluate(Map<Character, Boolean> propVarValues);
  
  boolean isPropositional();
  
  Formula copy();
  
  String toString();
}
