package ee.ut.axiom.views;

import com.google.gson.Gson;

import ee.ut.axiom.models.Solution;
import ee.ut.axiom.sequentCalculus.DerivationNode;
import ee.ut.axiom.sequentCalculus.Sequent;

/**
 * @author Dmitri Gabbasov
 */
public class SimpleSolution {
  public String derivation;
  public boolean completed;
  public int steps;
  public boolean propositional;
  
  public SimpleSolution() {
  }
  
  public SimpleSolution(Solution solution) {
    derivation = solution.derivation;
    completed = solution.completed;
    steps = solution.steps;
    propositional = Sequent.parse(solution.task.sequent).isPropositional();
  }
  
  public static SimpleSolution empty(String sequent) {
    SimpleSolution ss = new SimpleSolution();
    ss.derivation = new Gson().toJson(new DerivationNode(sequent));
    ss.propositional = Sequent.parse(sequent).isPropositional();
    return ss;
  }
}
