package ee.ut.axiom.views;

import java.util.List;
import java.util.stream.Collectors;

import com.google.common.collect.Lists;

import ee.ut.axiom.models.Solution;
import ee.ut.axiom.models.Taskset;

/**
 * @author Dmitri Gabbasov
 */
public class TasksetWithSolutionInfo {
  public int id;
  public String name;
  public List<TaskWithSolutionInfo> tasks;
  public boolean lemmasAllowed;

  public TasksetWithSolutionInfo() {
  }

  public TasksetWithSolutionInfo(Taskset taskset, List<Solution> solutions) {
    id = taskset.id;
    name = taskset.name;
    tasks = Lists.newArrayList(taskset.tasks).stream().map(task -> {
      Solution solution = solutions.stream().filter(sol -> sol.task.equals(task)).findFirst().orElse(null);
      return new TaskWithSolutionInfo(task, solution);
    }).collect(Collectors.toList());
    lemmasAllowed = taskset.lemmasAllowed;
  }
}
